#include "rFlex.h"
#include "serial.h"

#include <fcntl.h>

struct reflex *reflexSerialNew(char const* device, int rate, int* fd, void *pArg)
{
	int rFlexFd = openRaw(device, O_RDWR | O_NONBLOCK);
	if (rFlexFd < 0) {
		fprintf(stderr, "ERROR: failed to set up device %s\n", device);
		return 0;
	}
	if (!setBaudRate(rFlexFd, rate)) {
		fprintf(stderr, "ERROR: failed to set baud rate to %i for %s (%i)\n", rate, device, rFlexFd);
		close(rFlexFd);
		return 0;
	}

	if (fd)
		*fd = rFlexFd;

	return reflexNew(rFlexFd, pArg);
}
 
